//#define CONFIG_COMPAT

#define SIZE_DMA (4UL << 20)

#define VENDOR_ID 		0xa203
#define DEVICE_ID_mPCIe_UD1 	0x9470
#define DEVICE_ID_UDx   		0x9472
#define DEVICE_ID_mPCIe 		0x9473

#define FIRST_MINOR 0
#define MINOR_CNT 100

#define PORT_START 0x0000
#define PORT_END 0x1ffffh

#define devicename "milstd1553ud"

#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/version.h>
#include <linux/types.h>
#include <linux/kdev_t.h>
#include <linux/init.h>
#include <linux/interrupt.h>
#include <linux/fs.h>
#include <linux/pci.h>
#include <asm/io.h>
#include <asm/uaccess.h>  //copy_to/from_user for kernel 2.6
#include <linux/cdev.h>
#include <linux/ioport.h>
#include <linux/pid.h>
#include <linux/sched.h>
#include <linux/irqreturn.h>
#include <linux/mm.h>

#include "ioctl_man.h"

struct dev_state
{
	int dev_open;
	ssize_t byte_read;
	ssize_t byte_write;
};

// for interrupts and signals
typedef struct {
int int_id; // Interrupt type
int enable_tr; // Subaddr rcv
int enable_rcv; // Subaddr tr
unsigned long proc_pid[28]; // PID proc
unsigned long sig_no[28];   // Number signal
int fl[28]; // =1 - event ok
} SDI;

typedef struct {
	phys_addr_t base_addr0;
	void *base_addr;
	void *addr_dma;
	int m_nProgDMACount[4];
	int nblock_dma_0;
	int uk_dma;
	SIG_STR sig_str;
	int sig_tosend;
	int flag_1;
	struct pci_dev *pdev;
	int sig_pid;
	struct task_struct *sig_tsk;
	dma_addr_t addr_dma_1;
	int irq_num;
	unsigned int device_id;
	unsigned int vendor_id;
	char dev_name[30];
	int minor;
	struct mutex mutex_dma;
	SDI di;
	long bars;
	int mode; // 0 - OU; 1 - BC; 2 - BM; 3 - BM + OU
	char revision;
	int dev_type;
} DEVICE_MIL;

/*#define INT_MY_HDAT	0x00000001
#define INT_MY_QDAT	0x00000002
#define INT_MY_FLASH	0x00000004
#define INT_MY_SADDR	0x00000008
#define INT_MY_MC	0x00000010
#define INT_MY_ERR	0x00000020
#define INT_MY_BC	0x00000040

#define RT_INT_TEN	0x00000001
#define RT_INT_REN	0x00000002
#define RT_INT_ERR	0x00000004
#define RT_INT_MC	0x00000008

#define INT_HDAT	0x00000001
#define INT_QDAT	0x00000002
#define INT_FLASH	0x00000008
#define INT_SADDR	0x00000010
#define INT_MC_ERR	0x00000020
#define INT_BC		0x00000040*/

// for masks
#define B0	0x00000001
#define B1	0x00000002
#define B2	0x00000004
#define B3	0x00000008
#define B4	0x00000010
#define B5	0x00000020
#define B6	0x00000040
#define B7	0x00000080
#define B8	0x00000100
#define B9	0x00000200
#define B10	0x00000400
#define B11	0x00000800
#define B12	0x00001000
#define B13	0x00002000
#define B14	0x00004000
#define B15	0x00008000
#define B16	0x00010000
#define B17	0x00020000
#define B18	0x00040000
#define B19	0x00080000
#define B20	0x00100000
#define B21	0x00200000
#define B22	0x00400000
#define B23	0x00800000
#define B24	0x01000000
#define B25	0x02000000
#define B26	0x04000000
#define B27	0x08000000
#define B28	0x10000000
#define B29	0x20000000
#define B30	0x40000000
#define B31	0x80000000
